// ExeUpdaterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ExeUpdater.h"
#include "ExeUpdaterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExeUpdaterDlg dialog

CExeUpdaterDlg::CExeUpdaterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExeUpdaterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExeUpdaterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExeUpdaterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExeUpdaterDlg)
	DDX_Control(pDX, IDC_EDIT_DEST_PATH, m_DestPath);
	DDX_Control(pDX, IDC_EDIT_SOURCE_PATH, m_SrcPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExeUpdaterDlg, CDialog)
	//{{AFX_MSG_MAP(CExeUpdaterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CHANGE, OnButtonChangeIcon)
	ON_BN_CLICKED(IDC_BUTTON_SOURCE_BROWSE, OnButtonBrowseSource)
	ON_BN_CLICKED(IDC_BUTTON_DEST_BROWSE, OnButtonBrowseDest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExeUpdaterDlg message handlers

BOOL CExeUpdaterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExeUpdaterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExeUpdaterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExeUpdaterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

struct
{
    WORD wLanguage;
    WORD wCodePage;
} *lpTranslate;

void CExeUpdaterDlg::OnButtonChangeIcon() 
{
	CString             lpszFile;// _T("e:\\sharedoc\\memcard.exe");
	CString             lpszSourceFile;// = _T("e:\\sharedoc\\pheditor.exe");

	m_SrcPath.GetWindowText(lpszSourceFile);
	m_DestPath.GetWindowText(lpszFile);

	HRSRC hRes;         // handle/ptr. to res. info. in hExe 
	HANDLE hUpdateRes;  // update resource handle 
	char *lpResLock;    // pointer to resource data 
	HRSRC hResLoad;     // handle to loaded resource 
	BOOL result; 
	HMODULE hSrcExe,hDestExe;
	int iLoop;

	//Load the source exe from where we need the icon
	hSrcExe = LoadLibrary(lpszSourceFile);
	if(hSrcExe == NULL)
		return;

	// Locate the ICON resource in the .EXE file. 
	for(iLoop = 1;;iLoop++)
	{
		CString str;
		str.Format("#%d",iLoop);
		hRes = FindResource(hSrcExe, str, RT_ICON); 
		if (hRes == NULL) 
			continue ; 
		else if(iLoop == 10)
			return;
		else
			break;
	}

	// Load the ICON into global memory. 
	hResLoad = (HRSRC)LoadResource(hSrcExe, hRes); 
	if (hResLoad == NULL) 
		return ; 

	// Lock the ICON into global memory. 
	lpResLock = (char*)LockResource(hResLoad); 
	if (lpResLock == NULL) 
		return ; 

	hDestExe = LoadLibrary(lpszFile);
	if(hDestExe == NULL)
		return;
	// Locate the ICON resource in the .EXE file. 
	for(iLoop = 1;;iLoop++)
	{
		CString str;
		str.Format("#%d",iLoop);
		if (FindResource(hDestExe, str, RT_ICON) == NULL) 
			continue ; 
		else if(iLoop == 10)
			break;
		else
			break;
	}
	FreeLibrary(hDestExe);

	// Open the file to which you want to add the ICON resource. 
	hUpdateRes = BeginUpdateResource(lpszFile, FALSE); 
	if (hUpdateRes == NULL) 
		return ; 

	result = UpdateResource(hUpdateRes,       // update resource handle 
		RT_ICON,                   // change dialog box resource 
		MAKEINTRESOURCE(1),
		MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),  // neutral language
		lpResLock,                   // ptr to resource info 
		SizeofResource(hSrcExe, hRes)); // size of resource info. 

	if (result == FALSE) 
		return ; 

	// Write changes then close it. 
	if (!EndUpdateResource(hUpdateRes, FALSE)) 
	{ 
		return ;
	} 
}


void CExeUpdaterDlg::OnButtonBrowseSource() 
{
	CFileDialog fileOpen(TRUE);
	if(fileOpen.DoModal() == IDOK)
	{
		m_SrcPath.SetWindowText(fileOpen.GetPathName());
	}
}

void CExeUpdaterDlg::OnButtonBrowseDest() 
{
	CFileDialog fileOpen(TRUE);
	if(fileOpen.DoModal() == IDOK)
	{
		m_DestPath.SetWindowText(fileOpen.GetPathName());
	}
}
